/* game.c generated by valac 0.54.6, the Vala compiler
 * generated from game.vala, do not modify */

/*
 * Copyright 2020 Andrey Kutejko <andy128k@gmail.com>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, see <http://www.gnu.org/licenses/>.
 *
 * For more details see the file COPYING.
 */

#include <glib-object.h>
#include <glib.h>
#include <string.h>
#include <stdlib.h>
#include <gee.h>
#include <gobject/gvaluecollector.h>

#define GAME_GAME_WIDTH 45
#define GAME_GAME_HEIGHT 30
#define GAME_DEAD_DELAY 30
#define GAME_CHANGE_DELAY 20
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

typedef enum  {
	PLAYER_COMMAND_NW = 0,
	PLAYER_COMMAND_N,
	PLAYER_COMMAND_NE,
	PLAYER_COMMAND_W,
	PLAYER_COMMAND_STAY,
	PLAYER_COMMAND_E,
	PLAYER_COMMAND_SW,
	PLAYER_COMMAND_S,
	PLAYER_COMMAND_SE,
	PLAYER_COMMAND_SAFE_TELEPORT,
	PLAYER_COMMAND_RANDOM_TELEPORT,
	PLAYER_COMMAND_WAIT
} PlayerCommand;

#define TYPE_PLAYER_COMMAND (player_command_get_type ())

#define TYPE_DIRECTION (direction_get_type ())
typedef struct _Direction Direction;

#define TYPE_GAME (game_get_type ())
#define GAME(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_GAME, Game))
#define GAME_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_GAME, GameClass))
#define IS_GAME(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_GAME))
#define IS_GAME_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_GAME))
#define GAME_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_GAME, GameClass))

typedef struct _Game Game;
typedef struct _GameClass GameClass;
typedef struct _GamePrivate GamePrivate;
typedef enum  {
	GAME_STATE_PLAYING = 1,
	GAME_STATE_WAITING,
	GAME_STATE_COMPLETE,
	GAME_STATE_DEAD,
	GAME_STATE_TYPE2,
	GAME_STATE_WAITING_TYPE2
} GameState;

#define GAME_TYPE_STATE (game_state_get_type ())

#define TYPE_ARENA (arena_get_type ())
#define ARENA(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_ARENA, Arena))
#define ARENA_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_ARENA, ArenaClass))
#define IS_ARENA(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_ARENA))
#define IS_ARENA_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_ARENA))
#define ARENA_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_ARENA, ArenaClass))

typedef struct _Arena Arena;
typedef struct _ArenaClass ArenaClass;

#define TYPE_GAME_CONFIG (game_config_get_type ())
typedef struct _GameConfig GameConfig;

#define ARENA_TYPE_COORDS (arena_coords_get_type ())
typedef struct _ArenaCoords ArenaCoords;
typedef enum  {
	GAME_EVENT_TELEPORTED,
	GAME_EVENT_SPLAT,
	GAME_EVENT_LEVEL_COMPLETE,
	GAME_EVENT_DEATH,
	GAME_EVENT_SCORED,
	GAME_EVENT_VICTORY,
	GAME_EVENT_NO_TELEPORT_LOCATIONS,
	GAME_EVENT_NO_SAFE_TELEPORT_LOCATIONS
} GameEvent;

#define GAME_TYPE_EVENT (game_event_get_type ())
typedef enum  {
	GAME_MOVE_SAFETY_UNSAFE,
	GAME_MOVE_SAFETY_SAFE,
	GAME_MOVE_SAFETY_SUPER_SAFE
} GameMoveSafety;

#define GAME_TYPE_MOVE_SAFETY (game_move_safety_get_type ())
#define _arena_unref0(var) ((var == NULL) ? NULL : (var = (arena_unref (var), NULL)))
#define _arena_coords_free0(var) ((var == NULL) ? NULL : (var = (arena_coords_free (var), NULL)))
#define _g_rand_free0(var) ((var == NULL) ? NULL : (var = (g_rand_free (var), NULL)))
typedef enum  {
	OBJECT_TYPE_PLAYER = 0,
	OBJECT_TYPE_HEAP = 1,
	OBJECT_TYPE_ROBOT1 = 2,
	OBJECT_TYPE_ROBOT2 = 3,
	OBJECT_TYPE_NONE = 99
} ObjectType;

#define TYPE_OBJECT_TYPE (object_type_get_type ())

#define ARENA_ITERABLE_TYPE_ITERATOR (arena_iterable_iterator_get_type ())
#define ARENA_ITERABLE_ITERATOR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), ARENA_ITERABLE_TYPE_ITERATOR, ArenaIterableIterator))
#define ARENA_ITERABLE_ITERATOR_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), ARENA_ITERABLE_TYPE_ITERATOR, ArenaIterableIteratorClass))
#define ARENA_ITERABLE_IS_ITERATOR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), ARENA_ITERABLE_TYPE_ITERATOR))
#define ARENA_ITERABLE_IS_ITERATOR_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), ARENA_ITERABLE_TYPE_ITERATOR))
#define ARENA_ITERABLE_ITERATOR_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), ARENA_ITERABLE_TYPE_ITERATOR, ArenaIterableIteratorClass))

typedef struct _ArenaIterableIterator ArenaIterableIterator;
typedef struct _ArenaIterableIteratorClass ArenaIterableIteratorClass;

#define TYPE_ARENA_ITERABLE (arena_iterable_get_type ())
#define ARENA_ITERABLE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_ARENA_ITERABLE, ArenaIterable))
#define ARENA_ITERABLE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_ARENA_ITERABLE, ArenaIterableClass))
#define IS_ARENA_ITERABLE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_ARENA_ITERABLE))
#define IS_ARENA_ITERABLE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_ARENA_ITERABLE))
#define ARENA_ITERABLE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_ARENA_ITERABLE, ArenaIterableClass))

typedef struct _ArenaIterable ArenaIterable;
typedef struct _ArenaIterableClass ArenaIterableClass;
#define _arena_iterable_unref0(var) ((var == NULL) ? NULL : (var = (arena_iterable_unref (var), NULL)))
#define _arena_iterable_iterator_unref0(var) ((var == NULL) ? NULL : (var = (arena_iterable_iterator_unref (var), NULL)))

#define GAME_TYPE_ARENA_CHANGE (game_arena_change_get_type ())
typedef struct _GameArenaChange GameArenaChange;
typedef void (*GameKillTracker) (ObjectType victim, gpointer user_data);
typedef struct _Block4Data Block4Data;
typedef ObjectType (*ArenaMapper) (ObjectType obj, gpointer user_data);
#define _game_arena_change_free0(var) ((var == NULL) ? NULL : (var = (game_arena_change_free (var), NULL)))

#define GAME_TYPE_STATUS (game_status_get_type ())
typedef struct _GameStatus GameStatus;
typedef struct _ParamSpecGame ParamSpecGame;
enum  {
	GAME_GAME_EVENT_SIGNAL,
	GAME_NUM_SIGNALS
};
static guint game_signals[GAME_NUM_SIGNALS] = {0};
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _Direction {
	PlayerCommand cmd;
	gint dx;
	gint dy;
};

struct _Game {
	GTypeInstance parent_instance;
	volatile int ref_count;
	GamePrivate * priv;
};

struct _GameClass {
	GTypeClass parent_class;
	void (*finalize) (Game *self);
};

struct _GameConfig {
	gchar* description;
	gint initial_type1;
	gint initial_type2;
	gint increment_type1;
	gint increment_type2;
	gint maximum_type1;
	gint maximum_type2;
	gint score_type1;
	gint score_type2;
	gint score_type1_waiting;
	gint score_type2_waiting;
	gint score_type1_splatted;
	gint score_type2_splatted;
	gint num_robots_per_safe;
	gint safe_score_boundary;
	gint initial_safe_teleports;
	gint free_safe_teleports;
	gint max_safe_teleports;
	gboolean moveable_heaps;
};

struct _ArenaCoords {
	gint x;
	gint y;
};

struct _GamePrivate {
	GameState _state;
	Arena* _arena;
	GameConfig _config;
	ArenaCoords _player;
	ArenaCoords* _splat;
	GRand* rand;
	gint endlev_counter;
	gint current_level;
	gint score;
	gint kills;
	gint score_step;
	gint safe_teleports;
};

struct _GameArenaChange {
	Arena* arena;
	ArenaCoords player;
	ArenaCoords* push;
};

struct _Block4Data {
	int _ref_count_;
	GeePredicate is_chaser;
	gpointer is_chaser_target;
};

struct _GameStatus {
	gint score;
	gint current_level;
	gint safe_teleports;
};

struct _ParamSpecGame {
	GParamSpec parent_instance;
};

static gint Game_private_offset;
static gpointer game_parent_class = NULL;

VALA_EXTERN GType player_command_get_type (void) G_GNUC_CONST ;
VALA_EXTERN PlayerCommand player_command_from_direction (gint dx,
                                             gint dy);
VALA_EXTERN GType direction_get_type (void) G_GNUC_CONST ;
VALA_EXTERN Direction* direction_dup (const Direction* self);
VALA_EXTERN void direction_free (Direction* self);
VALA_EXTERN gboolean player_command_to_direction (PlayerCommand self,
                                      gint* dx,
                                      gint* dy);
VALA_EXTERN gpointer game_ref (gpointer instance);
VALA_EXTERN void game_unref (gpointer instance);
VALA_EXTERN GParamSpec* param_spec_game (const gchar* name,
                             const gchar* nick,
                             const gchar* blurb,
                             GType object_type,
                             GParamFlags flags);
VALA_EXTERN void value_set_game (GValue* value,
                     gpointer v_object);
VALA_EXTERN void value_take_game (GValue* value,
                      gpointer v_object);
VALA_EXTERN gpointer value_get_game (const GValue* value);
VALA_EXTERN GType game_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Game, game_unref)
VALA_EXTERN GType game_state_get_type (void) G_GNUC_CONST ;
VALA_EXTERN gpointer arena_ref (gpointer instance);
VALA_EXTERN void arena_unref (gpointer instance);
VALA_EXTERN GParamSpec* param_spec_arena (const gchar* name,
                              const gchar* nick,
                              const gchar* blurb,
                              GType object_type,
                              GParamFlags flags);
VALA_EXTERN void value_set_arena (GValue* value,
                      gpointer v_object);
VALA_EXTERN void value_take_arena (GValue* value,
                       gpointer v_object);
VALA_EXTERN gpointer value_get_arena (const GValue* value);
VALA_EXTERN GType arena_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Arena, arena_unref)
VALA_EXTERN GType game_config_get_type (void) G_GNUC_CONST ;
VALA_EXTERN GameConfig* game_config_dup (const GameConfig* self);
VALA_EXTERN void game_config_free (GameConfig* self);
VALA_EXTERN void game_config_copy (const GameConfig* self,
                       GameConfig* dest);
VALA_EXTERN void game_config_destroy (GameConfig* self);
VALA_EXTERN GType arena_coords_get_type (void) G_GNUC_CONST ;
VALA_EXTERN ArenaCoords* arena_coords_dup (const ArenaCoords* self);
VALA_EXTERN void arena_coords_free (ArenaCoords* self);
VALA_EXTERN GType game_event_get_type (void) G_GNUC_CONST ;
VALA_EXTERN GType game_move_safety_get_type (void) G_GNUC_CONST ;
VALA_EXTERN Game* game_new (void);
VALA_EXTERN Game* game_construct (GType object_type);
VALA_EXTERN Arena* arena_new (gint width,
                  gint height);
VALA_EXTERN Arena* arena_construct (GType object_type,
                        gint width,
                        gint height);
static void game_set_arena (Game* self,
                     Arena* value);
static void game_set_state (Game* self,
                     GameState value);
static void game_kill_player (Game* self);
VALA_EXTERN Arena* game_get_arena (Game* self);
VALA_EXTERN GType object_type_get_type (void) G_GNUC_CONST ;
VALA_EXTERN void arena_set (Arena* self,
                gint x,
                gint y,
                ObjectType obj);
VALA_EXTERN void game_get_player (Game* self,
                      ArenaCoords * result);
static void game_add_kill (Game* self,
                    ObjectType type);
VALA_EXTERN GameState game_get_state (Game* self);
VALA_EXTERN void game_get_config (Game* self,
                      GameConfig * result);
static gint game_max_robots (Game* self);
VALA_EXTERN gint arena_get_width (Arena* self);
VALA_EXTERN gint arena_get_height (Arena* self);
static void game_generate_level (Game* self);
VALA_EXTERN void arena_clear (Arena* self);
static void game_set_player (Game* self,
                      ArenaCoords * value);
static void game_place_randomly (Game* self,
                          ObjectType obj);
VALA_EXTERN gpointer arena_iterable_iterator_ref (gpointer instance);
VALA_EXTERN void arena_iterable_iterator_unref (gpointer instance);
VALA_EXTERN GParamSpec* arena_iterable_param_spec_iterator (const gchar* name,
                                                const gchar* nick,
                                                const gchar* blurb,
                                                GType object_type,
                                                GParamFlags flags);
VALA_EXTERN void arena_iterable_value_set_iterator (GValue* value,
                                        gpointer v_object);
VALA_EXTERN void arena_iterable_value_take_iterator (GValue* value,
                                         gpointer v_object);
VALA_EXTERN gpointer arena_iterable_value_get_iterator (const GValue* value);
VALA_EXTERN GType arena_iterable_iterator_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (ArenaIterableIterator, arena_iterable_iterator_unref)
VALA_EXTERN gpointer arena_iterable_ref (gpointer instance);
VALA_EXTERN void arena_iterable_unref (gpointer instance);
VALA_EXTERN GParamSpec* param_spec_arena_iterable (const gchar* name,
                                       const gchar* nick,
                                       const gchar* blurb,
                                       GType object_type,
                                       GParamFlags flags);
VALA_EXTERN void value_set_arena_iterable (GValue* value,
                               gpointer v_object);
VALA_EXTERN void value_take_arena_iterable (GValue* value,
                                gpointer v_object);
VALA_EXTERN gpointer value_get_arena_iterable (const GValue* value);
VALA_EXTERN GType arena_iterable_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (ArenaIterable, arena_iterable_unref)
VALA_EXTERN ArenaIterable* arena_iterate_from (Arena* self,
                                   gint x,
                                   gint y);
VALA_EXTERN ArenaIterableIterator* arena_iterable_iterator (ArenaIterable* self);
VALA_EXTERN ArenaCoords* arena_iterable_iterator_next_value (ArenaIterableIterator* self);
VALA_EXTERN ObjectType arena_get (Arena* self,
                      gint x,
                      gint y);
static GType game_arena_change_get_type (void) G_GNUC_CONST  G_GNUC_UNUSED ;
static GameArenaChange* game_arena_change_dup (const GameArenaChange* self);
static void game_arena_change_free (GameArenaChange* self);
static void game_arena_change_copy (const GameArenaChange* self,
                             GameArenaChange* dest);
static void game_arena_change_destroy (GameArenaChange* self);
static void game_update_arena (Game* self,
                        GameArenaChange* change);
static void game_set_splat (Game* self,
                     ArenaCoords* value);
VALA_EXTERN gint arena_count (Arena* self,
                  GeePredicate predicate,
                  gpointer predicate_target);
static gboolean ___lambda14_ (Game* self,
                       ObjectType obj);
static gboolean ____lambda14__gee_predicate (gconstpointer g,
                                      gpointer self);
VALA_EXTERN void game_tick (Game* self);
static Arena* game_move_type2_robots (Game* self);
static void game_move_robots (Game* self);
VALA_EXTERN void game_start_new_game (Game* self);
static Arena* game_move_all_robots (Game* self);
static Arena* game_chase (Arena* arena,
                   GeePredicate is_chaser,
                   gpointer is_chaser_target,
                   gint x,
                   gint y,
                   GameKillTracker track_kill,
                   gpointer track_kill_target);
static gboolean __lambda18_ (Game* self,
                      ObjectType obj);
static gboolean ___lambda18__gee_predicate (gconstpointer g,
                                     gpointer self);
static void __lambda19_ (Game* self,
                  ObjectType victim);
static void ___lambda19__game_kill_tracker (ObjectType victim,
                                     gpointer self);
static gboolean __lambda16_ (Game* self,
                      ObjectType obj);
static gboolean ___lambda16__gee_predicate (gconstpointer g,
                                     gpointer self);
static void __lambda17_ (Game* self,
                  ObjectType victim);
static void ___lambda17__game_kill_tracker (ObjectType victim,
                                     gpointer self);
static gboolean __lambda20_ (Game* self,
                      ObjectType obj);
static gboolean ___lambda20__gee_predicate (gconstpointer g,
                                     gpointer self);
static Block4Data* block4_data_ref (Block4Data* _data4_);
static void block4_data_unref (void * _userdata_);
VALA_EXTERN Arena* arena_map (Arena* self,
                  ArenaMapper mapper,
                  gpointer mapper_target);
static ObjectType __lambda15_ (Block4Data* _data4_,
                        ObjectType obj);
static ObjectType ___lambda15__arena_mapper (ObjectType obj,
                                      gpointer self);
static gboolean game_check_safe (Game* self,
                          GameArenaChange* change);
static gboolean __lambda21_ (Game* self,
                      ObjectType obj);
static gboolean ___lambda21__gee_predicate (gconstpointer g,
                                     gpointer self);
static gboolean __lambda22_ (Game* self,
                      ObjectType obj);
static gboolean ___lambda22__gee_predicate (gconstpointer g,
                                     gpointer self);
static GameArenaChange* game_try_push_heap (Game* self,
                                     gint dx,
                                     gint dy);
VALA_EXTERN void arena_coords_move (ArenaCoords *self,
                        gint dx,
                        gint dy,
                        ArenaCoords* result);
VALA_EXTERN gboolean arena_are_coords_valid (Arena* self,
                                 ArenaCoords* coords);
static ObjectType __lambda23_ (Game* self,
                        ObjectType obj);
static ObjectType ___lambda23__arena_mapper (ObjectType obj,
                                      gpointer self);
static GameArenaChange* game_try_player_move (Game* self,
                                       gint dx,
                                       gint dy);
static void game_move_player_to (Game* self,
                          ArenaCoords* coords,
                          GameArenaChange* result);
static gboolean game_safe_move_available (Game* self);
static ObjectType __lambda24_ (Game* self,
                        ObjectType obj);
static ObjectType ___lambda24__arena_mapper (ObjectType obj,
                                      gpointer self);
static gboolean game_player_move (Game* self,
                           gint dx,
                           gint dy,
                           GameMoveSafety safety);
static gboolean game_random_teleport (Game* self);
static gboolean game_safe_teleport (Game* self);
VALA_EXTERN gboolean game_player_command (Game* self,
                              PlayerCommand cmd,
                              GameMoveSafety safety);
VALA_EXTERN void game_set_config (Game* self,
                      GameConfig * value);
VALA_EXTERN gint game_get_width (Game* self);
VALA_EXTERN gint game_get_height (Game* self);
VALA_EXTERN ArenaCoords* game_get_splat (Game* self);
VALA_EXTERN GType game_status_get_type (void) G_GNUC_CONST ;
VALA_EXTERN GameStatus* game_status_dup (const GameStatus* self);
VALA_EXTERN void game_status_free (GameStatus* self);
VALA_EXTERN void game_get_status (Game* self,
                      GameStatus * result);
static void g_cclosure_user_marshal_VOID__ENUM_INT (GClosure * closure,
                                             GValue * return_value,
                                             guint n_param_values,
                                             const GValue * param_values,
                                             gpointer invocation_hint,
                                             gpointer marshal_data);
static void game_finalize (Game * obj);
static GType game_get_type_once (void);

const Direction directions[9] = {{PLAYER_COMMAND_NW, -1, -1}, {PLAYER_COMMAND_N, 0, -1}, {PLAYER_COMMAND_NE, 1, -1}, {PLAYER_COMMAND_W, -1, 0}, {PLAYER_COMMAND_STAY, 0, 0}, {PLAYER_COMMAND_E, 1, 0}, {PLAYER_COMMAND_SW, -1, 1}, {PLAYER_COMMAND_S, 0, 1}, {PLAYER_COMMAND_SE, 1, 1}};

PlayerCommand
player_command_from_direction (gint dx,
                               gint dy)
{
	PlayerCommand result = 0;
	{
		Direction* direction_collection = NULL;
		gint direction_collection_length1 = 0;
		gint _direction_collection_size_ = 0;
		gint direction_it = 0;
		direction_collection = directions;
		direction_collection_length1 = G_N_ELEMENTS (directions);
		for (direction_it = 0; direction_it < direction_collection_length1; direction_it = direction_it + 1) {
			Direction direction = {0};
			direction = direction_collection[direction_it];
			{
				gboolean _tmp0_ = FALSE;
				Direction _tmp1_;
				_tmp1_ = direction;
				if (_tmp1_.dx == dx) {
					Direction _tmp2_;
					_tmp2_ = direction;
					_tmp0_ = _tmp2_.dy == dy;
				} else {
					_tmp0_ = FALSE;
				}
				if (_tmp0_) {
					Direction _tmp3_;
					_tmp3_ = direction;
					result = _tmp3_.cmd;
					return result;
				}
			}
		}
	}
	result = PLAYER_COMMAND_STAY;
	return result;
}

gboolean
player_command_to_direction (PlayerCommand self,
                             gint* dx,
                             gint* dy)
{
	gint _vala_dx = 0;
	gint _vala_dy = 0;
	gboolean result = FALSE;
	{
		Direction* direction_collection = NULL;
		gint direction_collection_length1 = 0;
		gint _direction_collection_size_ = 0;
		gint direction_it = 0;
		direction_collection = directions;
		direction_collection_length1 = G_N_ELEMENTS (directions);
		for (direction_it = 0; direction_it < direction_collection_length1; direction_it = direction_it + 1) {
			Direction direction = {0};
			direction = direction_collection[direction_it];
			{
				Direction _tmp0_;
				_tmp0_ = direction;
				if (_tmp0_.cmd == self) {
					Direction _tmp1_;
					Direction _tmp2_;
					_tmp1_ = direction;
					_vala_dx = _tmp1_.dx;
					_tmp2_ = direction;
					_vala_dy = _tmp2_.dy;
					result = TRUE;
					if (dx) {
						*dx = _vala_dx;
					}
					if (dy) {
						*dy = _vala_dy;
					}
					return result;
				}
			}
		}
	}
	_vala_dx = 0;
	_vala_dy = 0;
	result = FALSE;
	if (dx) {
		*dx = _vala_dx;
	}
	if (dy) {
		*dy = _vala_dy;
	}
	return result;
}

static GType
player_command_get_type_once (void)
{
	static const GEnumValue values[] = {{PLAYER_COMMAND_NW, "PLAYER_COMMAND_NW", "nw"}, {PLAYER_COMMAND_N, "PLAYER_COMMAND_N", "n"}, {PLAYER_COMMAND_NE, "PLAYER_COMMAND_NE", "ne"}, {PLAYER_COMMAND_W, "PLAYER_COMMAND_W", "w"}, {PLAYER_COMMAND_STAY, "PLAYER_COMMAND_STAY", "stay"}, {PLAYER_COMMAND_E, "PLAYER_COMMAND_E", "e"}, {PLAYER_COMMAND_SW, "PLAYER_COMMAND_SW", "sw"}, {PLAYER_COMMAND_S, "PLAYER_COMMAND_S", "s"}, {PLAYER_COMMAND_SE, "PLAYER_COMMAND_SE", "se"}, {PLAYER_COMMAND_SAFE_TELEPORT, "PLAYER_COMMAND_SAFE_TELEPORT", "safe-teleport"}, {PLAYER_COMMAND_RANDOM_TELEPORT, "PLAYER_COMMAND_RANDOM_TELEPORT", "random-teleport"}, {PLAYER_COMMAND_WAIT, "PLAYER_COMMAND_WAIT", "wait"}, {0, NULL, NULL}};
	GType player_command_type_id;
	player_command_type_id = g_enum_register_static ("PlayerCommand", values);
	return player_command_type_id;
}

GType
player_command_get_type (void)
{
	static volatile gsize player_command_type_id__volatile = 0;
	if (g_once_init_enter (&player_command_type_id__volatile)) {
		GType player_command_type_id;
		player_command_type_id = player_command_get_type_once ();
		g_once_init_leave (&player_command_type_id__volatile, player_command_type_id);
	}
	return player_command_type_id__volatile;
}

Direction*
direction_dup (const Direction* self)
{
	Direction* dup;
	dup = g_new0 (Direction, 1);
	memcpy (dup, self, sizeof (Direction));
	return dup;
}

void
direction_free (Direction* self)
{
	g_free (self);
}

static GType
direction_get_type_once (void)
{
	GType direction_type_id;
	direction_type_id = g_boxed_type_register_static ("Direction", (GBoxedCopyFunc) direction_dup, (GBoxedFreeFunc) direction_free);
	return direction_type_id;
}

GType
direction_get_type (void)
{
	static volatile gsize direction_type_id__volatile = 0;
	if (g_once_init_enter (&direction_type_id__volatile)) {
		GType direction_type_id;
		direction_type_id = direction_get_type_once ();
		g_once_init_leave (&direction_type_id__volatile, direction_type_id);
	}
	return direction_type_id__volatile;
}

static inline gpointer
game_get_instance_private (Game* self)
{
	return G_STRUCT_MEMBER_P (self, Game_private_offset);
}

static GType
game_state_get_type_once (void)
{
	static const GEnumValue values[] = {{GAME_STATE_PLAYING, "GAME_STATE_PLAYING", "playing"}, {GAME_STATE_WAITING, "GAME_STATE_WAITING", "waiting"}, {GAME_STATE_COMPLETE, "GAME_STATE_COMPLETE", "complete"}, {GAME_STATE_DEAD, "GAME_STATE_DEAD", "dead"}, {GAME_STATE_TYPE2, "GAME_STATE_TYPE2", "type2"}, {GAME_STATE_WAITING_TYPE2, "GAME_STATE_WAITING_TYPE2", "waiting-type2"}, {0, NULL, NULL}};
	GType game_state_type_id;
	game_state_type_id = g_enum_register_static ("GameState", values);
	return game_state_type_id;
}

GType
game_state_get_type (void)
{
	static volatile gsize game_state_type_id__volatile = 0;
	if (g_once_init_enter (&game_state_type_id__volatile)) {
		GType game_state_type_id;
		game_state_type_id = game_state_get_type_once ();
		g_once_init_leave (&game_state_type_id__volatile, game_state_type_id);
	}
	return game_state_type_id__volatile;
}

static GType
game_event_get_type_once (void)
{
	static const GEnumValue values[] = {{GAME_EVENT_TELEPORTED, "GAME_EVENT_TELEPORTED", "teleported"}, {GAME_EVENT_SPLAT, "GAME_EVENT_SPLAT", "splat"}, {GAME_EVENT_LEVEL_COMPLETE, "GAME_EVENT_LEVEL_COMPLETE", "level-complete"}, {GAME_EVENT_DEATH, "GAME_EVENT_DEATH", "death"}, {GAME_EVENT_SCORED, "GAME_EVENT_SCORED", "scored"}, {GAME_EVENT_VICTORY, "GAME_EVENT_VICTORY", "victory"}, {GAME_EVENT_NO_TELEPORT_LOCATIONS, "GAME_EVENT_NO_TELEPORT_LOCATIONS", "no-teleport-locations"}, {GAME_EVENT_NO_SAFE_TELEPORT_LOCATIONS, "GAME_EVENT_NO_SAFE_TELEPORT_LOCATIONS", "no-safe-teleport-locations"}, {0, NULL, NULL}};
	GType game_event_type_id;
	game_event_type_id = g_enum_register_static ("GameEvent", values);
	return game_event_type_id;
}

GType
game_event_get_type (void)
{
	static volatile gsize game_event_type_id__volatile = 0;
	if (g_once_init_enter (&game_event_type_id__volatile)) {
		GType game_event_type_id;
		game_event_type_id = game_event_get_type_once ();
		g_once_init_leave (&game_event_type_id__volatile, game_event_type_id);
	}
	return game_event_type_id__volatile;
}

static GType
game_move_safety_get_type_once (void)
{
	static const GEnumValue values[] = {{GAME_MOVE_SAFETY_UNSAFE, "GAME_MOVE_SAFETY_UNSAFE", "unsafe"}, {GAME_MOVE_SAFETY_SAFE, "GAME_MOVE_SAFETY_SAFE", "safe"}, {GAME_MOVE_SAFETY_SUPER_SAFE, "GAME_MOVE_SAFETY_SUPER_SAFE", "super-safe"}, {0, NULL, NULL}};
	GType game_move_safety_type_id;
	game_move_safety_type_id = g_enum_register_static ("GameMoveSafety", values);
	return game_move_safety_type_id;
}

GType
game_move_safety_get_type (void)
{
	static volatile gsize game_move_safety_type_id__volatile = 0;
	if (g_once_init_enter (&game_move_safety_type_id__volatile)) {
		GType game_move_safety_type_id;
		game_move_safety_type_id = game_move_safety_get_type_once ();
		g_once_init_leave (&game_move_safety_type_id__volatile, game_move_safety_type_id);
	}
	return game_move_safety_type_id__volatile;
}

Game*
game_construct (GType object_type)
{
	Game* self = NULL;
	Arena* _tmp0_;
	Arena* _tmp1_;
	GRand* _tmp2_;
	self = (Game*) g_type_create_instance (object_type);
	_tmp0_ = arena_new (GAME_GAME_WIDTH, GAME_GAME_HEIGHT);
	_tmp1_ = _tmp0_;
	game_set_arena (self, _tmp1_);
	_arena_unref0 (_tmp1_);
	_tmp2_ = g_rand_new ();
	_g_rand_free0 (self->priv->rand);
	self->priv->rand = _tmp2_;
	game_set_state (self, GAME_STATE_PLAYING);
	return self;
}

Game*
game_new (void)
{
	return game_construct (TYPE_GAME);
}

/**
     * Ends the current game.
     **/
static void
game_kill_player (Game* self)
{
	Arena* _tmp0_;
	ArenaCoords _tmp1_;
	ArenaCoords _tmp2_;
	g_return_if_fail (self != NULL);
	game_set_state (self, GAME_STATE_DEAD);
	_tmp0_ = self->priv->_arena;
	_tmp1_ = self->priv->_player;
	_tmp2_ = self->priv->_player;
	arena_set (_tmp0_, _tmp1_.x, _tmp2_.y, OBJECT_TYPE_PLAYER);
	self->priv->endlev_counter = 0;
	g_signal_emit (self, game_signals[GAME_GAME_EVENT_SIGNAL], 0, GAME_EVENT_DEATH, 0);
}

/**
     * add_kill
     * @type: robot type
     *
     * Description:
     * registers a robot kill and updates the score
     **/
static void
game_add_kill (Game* self,
               ObjectType type)
{
	gint si = 0;
	gboolean _tmp0_ = FALSE;
	GameState _tmp1_;
	GameConfig _tmp7_;
	GameConfig _tmp10_;
	GameConfig _tmp13_;
	g_return_if_fail (self != NULL);
	_tmp1_ = self->priv->_state;
	if (_tmp1_ == GAME_STATE_WAITING) {
		_tmp0_ = TRUE;
	} else {
		GameState _tmp2_;
		_tmp2_ = self->priv->_state;
		_tmp0_ = _tmp2_ == GAME_STATE_WAITING_TYPE2;
	}
	if (_tmp0_) {
		if (type == OBJECT_TYPE_ROBOT1) {
			GameConfig _tmp3_;
			_tmp3_ = self->priv->_config;
			si = _tmp3_.score_type1_waiting;
			self->priv->kills = self->priv->kills + 1;
		} else {
			GameConfig _tmp4_;
			_tmp4_ = self->priv->_config;
			si = _tmp4_.score_type2_waiting;
			self->priv->kills = self->priv->kills + 2;
		}
	} else {
		if (type == OBJECT_TYPE_ROBOT1) {
			GameConfig _tmp5_;
			_tmp5_ = self->priv->_config;
			si = _tmp5_.score_type1;
		} else {
			GameConfig _tmp6_;
			_tmp6_ = self->priv->_config;
			si = _tmp6_.score_type2;
		}
	}
	self->priv->score = self->priv->score + si;
	self->priv->score_step = self->priv->score_step + si;
	_tmp7_ = self->priv->_config;
	if (_tmp7_.safe_score_boundary > 0) {
		while (TRUE) {
			GameConfig _tmp8_;
			GameConfig _tmp9_;
			_tmp8_ = self->priv->_config;
			if (!(self->priv->score_step >= _tmp8_.safe_score_boundary)) {
				break;
			}
			self->priv->safe_teleports = self->priv->safe_teleports + 1;
			_tmp9_ = self->priv->_config;
			self->priv->score_step = self->priv->score_step - _tmp9_.safe_score_boundary;
		}
	}
	_tmp10_ = self->priv->_config;
	if (_tmp10_.num_robots_per_safe > 0) {
		while (TRUE) {
			GameConfig _tmp11_;
			GameConfig _tmp12_;
			_tmp11_ = self->priv->_config;
			if (!(self->priv->kills >= _tmp11_.num_robots_per_safe)) {
				break;
			}
			self->priv->safe_teleports = self->priv->safe_teleports + 1;
			_tmp12_ = self->priv->_config;
			self->priv->kills = self->priv->kills - _tmp12_.num_robots_per_safe;
		}
	}
	_tmp13_ = self->priv->_config;
	if (self->priv->safe_teleports > _tmp13_.max_safe_teleports) {
		GameConfig _tmp14_;
		_tmp14_ = self->priv->_config;
		self->priv->safe_teleports = _tmp14_.max_safe_teleports;
	}
}

static gint
game_max_robots (Game* self)
{
	Arena* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	Arena* _tmp3_;
	gint _tmp4_;
	gint _tmp5_;
	gint result = 0;
	g_return_val_if_fail (self != NULL, 0);
	_tmp0_ = self->priv->_arena;
	_tmp1_ = arena_get_width (_tmp0_);
	_tmp2_ = _tmp1_;
	_tmp3_ = self->priv->_arena;
	_tmp4_ = arena_get_height (_tmp3_);
	_tmp5_ = _tmp4_;
	result = (_tmp2_ * _tmp5_) / 2;
	return result;
}

/**
     * Creates a new level and populates it with robots
     **/
static void
game_generate_level (Game* self)
{
	Arena* _tmp0_;
	Arena* _tmp1_;
	gint _tmp2_;
	gint _tmp3_;
	Arena* _tmp4_;
	gint _tmp5_;
	gint _tmp6_;
	ArenaCoords _tmp7_ = {0};
	Arena* _tmp8_;
	ArenaCoords _tmp9_;
	ArenaCoords _tmp10_;
	gint num_robots1 = 0;
	GameConfig _tmp11_;
	GameConfig _tmp12_;
	GameConfig _tmp13_;
	gint num_robots2 = 0;
	GameConfig _tmp14_;
	GameConfig _tmp15_;
	GameConfig _tmp16_;
	GameConfig _tmp19_;
	GameConfig _tmp20_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->_arena;
	arena_clear (_tmp0_);
	_tmp1_ = self->priv->_arena;
	_tmp2_ = arena_get_width (_tmp1_);
	_tmp3_ = _tmp2_;
	_tmp4_ = self->priv->_arena;
	_tmp5_ = arena_get_height (_tmp4_);
	_tmp6_ = _tmp5_;
	memset (&_tmp7_, 0, sizeof (ArenaCoords));
	_tmp7_.x = _tmp3_ / 2;
	_tmp7_.y = _tmp6_ / 2;
	game_set_player (self, &_tmp7_);
	_tmp8_ = self->priv->_arena;
	_tmp9_ = self->priv->_player;
	_tmp10_ = self->priv->_player;
	arena_set (_tmp8_, _tmp9_.x, _tmp10_.y, OBJECT_TYPE_PLAYER);
	_tmp11_ = self->priv->_config;
	_tmp12_ = self->priv->_config;
	_tmp13_ = self->priv->_config;
	num_robots1 = MIN (_tmp11_.initial_type1 + (_tmp12_.increment_type1 * self->priv->current_level), _tmp13_.maximum_type1);
	_tmp14_ = self->priv->_config;
	_tmp15_ = self->priv->_config;
	_tmp16_ = self->priv->_config;
	num_robots2 = MIN (_tmp14_.initial_type2 + (_tmp15_.increment_type2 * self->priv->current_level), _tmp16_.maximum_type2);
	if ((num_robots1 + num_robots2) > game_max_robots (self)) {
		GameConfig _tmp17_;
		GameConfig _tmp18_;
		self->priv->current_level = 0;
		_tmp17_ = self->priv->_config;
		num_robots1 = _tmp17_.initial_type1;
		_tmp18_ = self->priv->_config;
		num_robots2 = _tmp18_.initial_type2;
		g_signal_emit (self, game_signals[GAME_GAME_EVENT_SIGNAL], 0, GAME_EVENT_VICTORY, 0);
	}
	_tmp19_ = self->priv->_config;
	self->priv->safe_teleports = self->priv->safe_teleports + _tmp19_.free_safe_teleports;
	_tmp20_ = self->priv->_config;
	if (self->priv->safe_teleports > _tmp20_.max_safe_teleports) {
		GameConfig _tmp21_;
		_tmp21_ = self->priv->_config;
		self->priv->safe_teleports = _tmp21_.max_safe_teleports;
	}
	{
		gint i = 0;
		i = 0;
		{
			gboolean _tmp22_ = FALSE;
			_tmp22_ = TRUE;
			while (TRUE) {
				if (!_tmp22_) {
					gint _tmp23_;
					i = i + 1;
					_tmp23_ = i;
				}
				_tmp22_ = FALSE;
				if (!(i < num_robots1)) {
					break;
				}
				game_place_randomly (self, OBJECT_TYPE_ROBOT1);
			}
		}
	}
	{
		gint i = 0;
		i = 0;
		{
			gboolean _tmp24_ = FALSE;
			_tmp24_ = TRUE;
			while (TRUE) {
				if (!_tmp24_) {
					gint _tmp25_;
					i = i + 1;
					_tmp25_ = i;
				}
				_tmp24_ = FALSE;
				if (!(i < num_robots2)) {
					break;
				}
				game_place_randomly (self, OBJECT_TYPE_ROBOT2);
			}
		}
	}
}

static void
game_place_randomly (Game* self,
                     ObjectType obj)
{
	gint rand_x = 0;
	GRand* _tmp0_;
	Arena* _tmp1_;
	gint _tmp2_;
	gint _tmp3_;
	gint rand_y = 0;
	GRand* _tmp4_;
	Arena* _tmp5_;
	gint _tmp6_;
	gint _tmp7_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->rand;
	_tmp1_ = self->priv->_arena;
	_tmp2_ = arena_get_width (_tmp1_);
	_tmp3_ = _tmp2_;
	rand_x = (gint) g_rand_int_range (_tmp0_, (gint32) 0, (gint32) _tmp3_);
	_tmp4_ = self->priv->rand;
	_tmp5_ = self->priv->_arena;
	_tmp6_ = arena_get_height (_tmp5_);
	_tmp7_ = _tmp6_;
	rand_y = (gint) g_rand_int_range (_tmp4_, (gint32) 0, (gint32) _tmp7_);
	{
		ArenaIterableIterator* _p_it = NULL;
		Arena* _tmp8_;
		ArenaIterable* _tmp9_;
		ArenaIterable* _tmp10_;
		ArenaIterableIterator* _tmp11_;
		ArenaIterableIterator* _tmp12_;
		ArenaCoords* p = NULL;
		_tmp8_ = self->priv->_arena;
		_tmp9_ = arena_iterate_from (_tmp8_, rand_x, rand_y);
		_tmp10_ = _tmp9_;
		_tmp11_ = arena_iterable_iterator (_tmp10_);
		_tmp12_ = _tmp11_;
		_arena_iterable_unref0 (_tmp10_);
		_p_it = _tmp12_;
		while (TRUE) {
			ArenaIterableIterator* _tmp13_;
			ArenaCoords* _tmp14_;
			ArenaCoords* _tmp15_;
			Arena* _tmp16_;
			ArenaCoords* _tmp17_;
			ArenaCoords* _tmp18_;
			_tmp13_ = _p_it;
			_tmp14_ = arena_iterable_iterator_next_value (_tmp13_);
			_arena_coords_free0 (p);
			p = _tmp14_;
			_tmp15_ = p;
			if (!(_tmp15_ != NULL)) {
				break;
			}
			_tmp16_ = self->priv->_arena;
			_tmp17_ = p;
			_tmp18_ = p;
			if (arena_get (_tmp16_, (*_tmp17_).x, (*_tmp18_).y) == OBJECT_TYPE_NONE) {
				Arena* _tmp19_;
				ArenaCoords* _tmp20_;
				ArenaCoords* _tmp21_;
				_tmp19_ = self->priv->_arena;
				_tmp20_ = p;
				_tmp21_ = p;
				arena_set (_tmp19_, (*_tmp20_).x, (*_tmp21_).y, obj);
				_arena_coords_free0 (p);
				_arena_iterable_iterator_unref0 (_p_it);
				return;
			}
		}
		_arena_coords_free0 (p);
		_arena_iterable_iterator_unref0 (_p_it);
	}
}

static gboolean
___lambda14_ (Game* self,
              ObjectType obj)
{
	gboolean _tmp0_ = FALSE;
	gboolean result = FALSE;
	if (obj == OBJECT_TYPE_ROBOT1) {
		_tmp0_ = TRUE;
	} else {
		_tmp0_ = obj == OBJECT_TYPE_ROBOT2;
	}
	result = _tmp0_;
	return result;
}

static gboolean
____lambda14__gee_predicate (gconstpointer g,
                             gpointer self)
{
	gboolean result;
	result = ___lambda14_ ((Game*) self, (ObjectType) ((gintptr) g));
	return result;
}

static void
game_update_arena (Game* self,
                   GameArenaChange* change)
{
	GameArenaChange _tmp0_;
	ArenaCoords* _tmp1_;
	GameArenaChange _tmp13_;
	ArenaCoords _tmp14_;
	GameArenaChange _tmp15_;
	Arena* _tmp16_;
	Arena* _tmp17_;
	ArenaCoords _tmp18_;
	ArenaCoords _tmp19_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (change != NULL);
	_tmp0_ = *change;
	_tmp1_ = _tmp0_.push;
	if (_tmp1_ != NULL) {
		Arena* _tmp2_;
		GameArenaChange _tmp3_;
		ArenaCoords* _tmp4_;
		GameArenaChange _tmp5_;
		ArenaCoords* _tmp6_;
		_tmp2_ = self->priv->_arena;
		_tmp3_ = *change;
		_tmp4_ = _tmp3_.push;
		_tmp5_ = *change;
		_tmp6_ = _tmp5_.push;
		switch (arena_get (_tmp2_, (*_tmp4_).x, (*_tmp6_).y)) {
			case OBJECT_TYPE_ROBOT1:
			{
				GameArenaChange _tmp7_;
				ArenaCoords* _tmp8_;
				GameConfig _tmp9_;
				_tmp7_ = *change;
				_tmp8_ = _tmp7_.push;
				game_set_splat (self, _tmp8_);
				g_signal_emit (self, game_signals[GAME_GAME_EVENT_SIGNAL], 0, GAME_EVENT_SPLAT, 0);
				_tmp9_ = self->priv->_config;
				self->priv->score = self->priv->score + _tmp9_.score_type1_splatted;
				break;
			}
			case OBJECT_TYPE_ROBOT2:
			{
				GameArenaChange _tmp10_;
				ArenaCoords* _tmp11_;
				GameConfig _tmp12_;
				_tmp10_ = *change;
				_tmp11_ = _tmp10_.push;
				game_set_splat (self, _tmp11_);
				g_signal_emit (self, game_signals[GAME_GAME_EVENT_SIGNAL], 0, GAME_EVENT_SPLAT, 0);
				_tmp12_ = self->priv->_config;
				self->priv->score = self->priv->score + _tmp12_.score_type2_splatted;
				break;
			}
			default:
			{
				break;
			}
		}
	}
	_tmp13_ = *change;
	_tmp14_ = _tmp13_.player;
	game_set_player (self, &_tmp14_);
	_tmp15_ = *change;
	_tmp16_ = _tmp15_.arena;
	game_set_arena (self, _tmp16_);
	_tmp17_ = self->priv->_arena;
	_tmp18_ = self->priv->_player;
	_tmp19_ = self->priv->_player;
	if (arena_get (_tmp17_, _tmp18_.x, _tmp19_.y) != OBJECT_TYPE_PLAYER) {
		game_kill_player (self);
	} else {
		Arena* _tmp20_;
		_tmp20_ = self->priv->_arena;
		if (arena_count (_tmp20_, ____lambda14__gee_predicate, self) <= 0) {
			game_set_state (self, GAME_STATE_COMPLETE);
			g_signal_emit (self, game_signals[GAME_GAME_EVENT_SIGNAL], 0, GAME_EVENT_LEVEL_COMPLETE, 0);
			self->priv->endlev_counter = 0;
		}
	}
}

static gpointer
_arena_ref0 (gpointer self)
{
	return self ? arena_ref (self) : NULL;
}

void
game_tick (Game* self)
{
	gboolean _tmp0_ = FALSE;
	GameState _tmp1_;
	g_return_if_fail (self != NULL);
	_tmp1_ = self->priv->_state;
	if (_tmp1_ == GAME_STATE_TYPE2) {
		_tmp0_ = TRUE;
	} else {
		GameState _tmp2_;
		_tmp2_ = self->priv->_state;
		_tmp0_ = _tmp2_ == GAME_STATE_WAITING_TYPE2;
	}
	if (_tmp0_) {
		Arena* new_arena = NULL;
		Arena* _tmp3_;
		GameArenaChange change = {0};
		Arena* _tmp4_;
		Arena* _tmp5_;
		ArenaCoords _tmp6_;
		GameArenaChange _tmp7_ = {0};
		GameArenaChange _tmp8_;
		GameState _tmp9_;
		_tmp3_ = game_move_type2_robots (self);
		new_arena = _tmp3_;
		_tmp4_ = new_arena;
		_tmp5_ = _arena_ref0 (_tmp4_);
		_tmp6_ = self->priv->_player;
		memset (&_tmp7_, 0, sizeof (GameArenaChange));
		_arena_unref0 (_tmp7_.arena);
		_tmp7_.arena = _tmp5_;
		_tmp7_.player = _tmp6_;
		_arena_coords_free0 (_tmp7_.push);
		_tmp7_.push = NULL;
		change = _tmp7_;
		_tmp8_ = change;
		game_update_arena (self, &_tmp8_);
		_tmp9_ = self->priv->_state;
		if (_tmp9_ == GAME_STATE_TYPE2) {
			game_set_state (self, GAME_STATE_PLAYING);
		} else {
			GameState _tmp10_;
			_tmp10_ = self->priv->_state;
			if (_tmp10_ == GAME_STATE_WAITING_TYPE2) {
				game_set_state (self, GAME_STATE_WAITING);
			}
		}
		game_arena_change_destroy (&change);
		_arena_unref0 (new_arena);
	} else {
		GameState _tmp11_;
		_tmp11_ = self->priv->_state;
		if (_tmp11_ == GAME_STATE_WAITING) {
			game_set_splat (self, NULL);
			game_move_robots (self);
		} else {
			GameState _tmp12_;
			_tmp12_ = self->priv->_state;
			if (_tmp12_ == GAME_STATE_COMPLETE) {
				gint _tmp13_;
				self->priv->endlev_counter = self->priv->endlev_counter + 1;
				_tmp13_ = self->priv->endlev_counter;
				if (self->priv->endlev_counter >= GAME_CHANGE_DELAY) {
					gint _tmp14_;
					self->priv->current_level = self->priv->current_level + 1;
					_tmp14_ = self->priv->current_level;
					game_generate_level (self);
					game_set_state (self, GAME_STATE_PLAYING);
					game_set_splat (self, NULL);
				}
			} else {
				GameState _tmp15_;
				_tmp15_ = self->priv->_state;
				if (_tmp15_ == GAME_STATE_DEAD) {
					gint _tmp16_;
					self->priv->endlev_counter = self->priv->endlev_counter + 1;
					_tmp16_ = self->priv->endlev_counter;
					if (self->priv->endlev_counter >= GAME_DEAD_DELAY) {
						if (self->priv->score > 0) {
							g_signal_emit (self, game_signals[GAME_GAME_EVENT_SIGNAL], 0, GAME_EVENT_SCORED, self->priv->score);
						}
						game_start_new_game (self);
					}
				}
			}
		}
	}
}

/**
     * Initialises everything needed to start a new game
     **/
void
game_start_new_game (Game* self)
{
	GameConfig _tmp0_;
	g_return_if_fail (self != NULL);
	self->priv->current_level = 0;
	self->priv->score = 0;
	self->priv->kills = 0;
	self->priv->score_step = 0;
	_tmp0_ = self->priv->_config;
	self->priv->safe_teleports = _tmp0_.initial_safe_teleports;
	game_set_splat (self, NULL);
	game_generate_level (self);
	game_set_state (self, GAME_STATE_PLAYING);
}

/**
     * Moves all of the robots and checks for collisions
     **/
static gboolean
__lambda18_ (Game* self,
             ObjectType obj)
{
	gboolean _tmp0_ = FALSE;
	gboolean result = FALSE;
	if (obj == OBJECT_TYPE_ROBOT1) {
		_tmp0_ = TRUE;
	} else {
		_tmp0_ = obj == OBJECT_TYPE_ROBOT2;
	}
	result = _tmp0_;
	return result;
}

static gboolean
___lambda18__gee_predicate (gconstpointer g,
                            gpointer self)
{
	gboolean result;
	result = __lambda18_ ((Game*) self, (ObjectType) ((gintptr) g));
	return result;
}

static void
__lambda19_ (Game* self,
             ObjectType victim)
{
	game_add_kill (self, victim);
}

static void
___lambda19__game_kill_tracker (ObjectType victim,
                                gpointer self)
{
	__lambda19_ ((Game*) self, victim);
}

static Arena*
game_move_all_robots (Game* self)
{
	Arena* _tmp0_;
	ArenaCoords _tmp1_;
	ArenaCoords _tmp2_;
	Arena* _tmp3_;
	Arena* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_arena;
	_tmp1_ = self->priv->_player;
	_tmp2_ = self->priv->_player;
	_tmp3_ = game_chase (_tmp0_, ___lambda18__gee_predicate, self, _tmp1_.x, _tmp2_.y, ___lambda19__game_kill_tracker, self);
	result = _tmp3_;
	return result;
}

/**
     * Makes the extra move for all of the type2 robots
     **/
static gboolean
__lambda16_ (Game* self,
             ObjectType obj)
{
	gboolean result = FALSE;
	result = obj == OBJECT_TYPE_ROBOT2;
	return result;
}

static gboolean
___lambda16__gee_predicate (gconstpointer g,
                            gpointer self)
{
	gboolean result;
	result = __lambda16_ ((Game*) self, (ObjectType) ((gintptr) g));
	return result;
}

static void
__lambda17_ (Game* self,
             ObjectType victim)
{
	game_add_kill (self, victim);
}

static void
___lambda17__game_kill_tracker (ObjectType victim,
                                gpointer self)
{
	__lambda17_ ((Game*) self, victim);
}

static Arena*
game_move_type2_robots (Game* self)
{
	Arena* _tmp0_;
	ArenaCoords _tmp1_;
	ArenaCoords _tmp2_;
	Arena* _tmp3_;
	Arena* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_arena;
	_tmp1_ = self->priv->_player;
	_tmp2_ = self->priv->_player;
	_tmp3_ = game_chase (_tmp0_, ___lambda16__gee_predicate, self, _tmp1_.x, _tmp2_.y, ___lambda17__game_kill_tracker, self);
	result = _tmp3_;
	return result;
}

/**
     * Starts the process of moving robots
     **/
static gboolean
__lambda20_ (Game* self,
             ObjectType obj)
{
	gboolean result = FALSE;
	result = obj == OBJECT_TYPE_ROBOT2;
	return result;
}

static gboolean
___lambda20__gee_predicate (gconstpointer g,
                            gpointer self)
{
	gboolean result;
	result = __lambda20_ ((Game*) self, (ObjectType) ((gintptr) g));
	return result;
}

static void
game_move_robots (Game* self)
{
	Arena* new_arena = NULL;
	Arena* _tmp0_;
	gint num_robots2 = 0;
	Arena* _tmp1_;
	GameArenaChange change = {0};
	Arena* _tmp4_;
	Arena* _tmp5_;
	ArenaCoords _tmp6_;
	GameArenaChange _tmp7_ = {0};
	GameArenaChange _tmp8_;
	g_return_if_fail (self != NULL);
	_tmp0_ = game_move_all_robots (self);
	new_arena = _tmp0_;
	_tmp1_ = new_arena;
	num_robots2 = arena_count (_tmp1_, ___lambda20__gee_predicate, self);
	if (num_robots2 > 0) {
		GameState _tmp2_;
		_tmp2_ = self->priv->_state;
		if (_tmp2_ == GAME_STATE_WAITING) {
			game_set_state (self, GAME_STATE_WAITING_TYPE2);
		} else {
			GameState _tmp3_;
			_tmp3_ = self->priv->_state;
			if (_tmp3_ == GAME_STATE_PLAYING) {
				game_set_state (self, GAME_STATE_TYPE2);
			}
		}
	}
	_tmp4_ = new_arena;
	_tmp5_ = _arena_ref0 (_tmp4_);
	_tmp6_ = self->priv->_player;
	memset (&_tmp7_, 0, sizeof (GameArenaChange));
	_arena_unref0 (_tmp7_.arena);
	_tmp7_.arena = _tmp5_;
	_tmp7_.player = _tmp6_;
	_arena_coords_free0 (_tmp7_.push);
	_tmp7_.push = NULL;
	change = _tmp7_;
	_tmp8_ = change;
	game_update_arena (self, &_tmp8_);
	game_arena_change_destroy (&change);
	_arena_unref0 (new_arena);
}

static Block4Data*
block4_data_ref (Block4Data* _data4_)
{
	g_atomic_int_inc (&_data4_->_ref_count_);
	return _data4_;
}

static void
block4_data_unref (void * _userdata_)
{
	Block4Data* _data4_;
	_data4_ = (Block4Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data4_->_ref_count_)) {
		g_slice_free (Block4Data, _data4_);
	}
}

static ObjectType
__lambda15_ (Block4Data* _data4_,
             ObjectType obj)
{
	gboolean _tmp0_ = FALSE;
	ObjectType result = 0;
	if (obj == OBJECT_TYPE_PLAYER) {
		_tmp0_ = TRUE;
	} else {
		_tmp0_ = _data4_->is_chaser ((gpointer) ((gintptr) obj), _data4_->is_chaser_target);
	}
	if (_tmp0_) {
		result = OBJECT_TYPE_NONE;
		return result;
	} else {
		result = obj;
		return result;
	}
}

static ObjectType
___lambda15__arena_mapper (ObjectType obj,
                           gpointer self)
{
	ObjectType result;
	result = __lambda15_ (self, obj);
	return result;
}

static Arena*
game_chase (Arena* arena,
            GeePredicate is_chaser,
            gpointer is_chaser_target,
            gint x,
            gint y,
            GameKillTracker track_kill,
            gpointer track_kill_target)
{
	Block4Data* _data4_;
	Arena* new_arena = NULL;
	Arena* _tmp0_;
	Arena* _tmp13_;
	Arena* result = NULL;
	g_return_val_if_fail (arena != NULL, NULL);
	_data4_ = g_slice_new0 (Block4Data);
	_data4_->_ref_count_ = 1;
	_data4_->is_chaser = is_chaser;
	_data4_->is_chaser_target = is_chaser_target;
	_tmp0_ = arena_map (arena, ___lambda15__arena_mapper, _data4_);
	new_arena = _tmp0_;
	{
		gint i = 0;
		i = 0;
		{
			gboolean _tmp1_ = FALSE;
			_tmp1_ = TRUE;
			while (TRUE) {
				gint _tmp3_;
				gint _tmp4_;
				if (!_tmp1_) {
					gint _tmp2_;
					i = i + 1;
					_tmp2_ = i;
				}
				_tmp1_ = FALSE;
				_tmp3_ = arena_get_width (arena);
				_tmp4_ = _tmp3_;
				if (!(i < _tmp4_)) {
					break;
				}
				{
					gint j = 0;
					j = 0;
					{
						gboolean _tmp5_ = FALSE;
						_tmp5_ = TRUE;
						while (TRUE) {
							gint _tmp7_;
							gint _tmp8_;
							ObjectType who = 0;
							if (!_tmp5_) {
								gint _tmp6_;
								j = j + 1;
								_tmp6_ = j;
							}
							_tmp5_ = FALSE;
							_tmp7_ = arena_get_height (arena);
							_tmp8_ = _tmp7_;
							if (!(j < _tmp8_)) {
								break;
							}
							who = arena_get (arena, i, j);
							if (_data4_->is_chaser ((gpointer) ((gintptr) who), _data4_->is_chaser_target)) {
								gint nx = 0;
								gint ny = 0;
								ObjectType destination = 0;
								Arena* _tmp9_;
								nx = i;
								ny = j;
								if (x < nx) {
									nx -= 1;
								}
								if (x > nx) {
									nx += 1;
								}
								if (y < ny) {
									ny -= 1;
								}
								if (y > ny) {
									ny += 1;
								}
								_tmp9_ = new_arena;
								destination = arena_get (_tmp9_, nx, ny);
								if (destination == OBJECT_TYPE_HEAP) {
									if (track_kill != NULL) {
										track_kill (who, track_kill_target);
									}
								} else {
									gboolean _tmp10_ = FALSE;
									if (destination == OBJECT_TYPE_ROBOT1) {
										_tmp10_ = TRUE;
									} else {
										_tmp10_ = destination == OBJECT_TYPE_ROBOT2;
									}
									if (_tmp10_) {
										Arena* _tmp11_;
										if (track_kill != NULL) {
											track_kill (who, track_kill_target);
											track_kill (destination, track_kill_target);
										}
										_tmp11_ = new_arena;
										arena_set (_tmp11_, nx, ny, OBJECT_TYPE_HEAP);
									} else {
										Arena* _tmp12_;
										_tmp12_ = new_arena;
										arena_set (_tmp12_, nx, ny, who);
									}
								}
							}
						}
					}
				}
			}
		}
	}
	_tmp13_ = new_arena;
	if (arena_get (_tmp13_, x, y) == OBJECT_TYPE_NONE) {
		Arena* _tmp14_;
		_tmp14_ = new_arena;
		arena_set (_tmp14_, x, y, OBJECT_TYPE_PLAYER);
	}
	result = new_arena;
	block4_data_unref (_data4_);
	_data4_ = NULL;
	return result;
}

/**
     * checks whether a given location is safe
     **/
static gboolean
__lambda21_ (Game* self,
             ObjectType obj)
{
	gboolean _tmp0_ = FALSE;
	gboolean result = FALSE;
	if (obj == OBJECT_TYPE_ROBOT1) {
		_tmp0_ = TRUE;
	} else {
		_tmp0_ = obj == OBJECT_TYPE_ROBOT2;
	}
	result = _tmp0_;
	return result;
}

static gboolean
___lambda21__gee_predicate (gconstpointer g,
                            gpointer self)
{
	gboolean result;
	result = __lambda21_ ((Game*) self, (ObjectType) ((gintptr) g));
	return result;
}

static gboolean
__lambda22_ (Game* self,
             ObjectType obj)
{
	gboolean result = FALSE;
	result = obj == OBJECT_TYPE_ROBOT2;
	return result;
}

static gboolean
___lambda22__gee_predicate (gconstpointer g,
                            gpointer self)
{
	gboolean result;
	result = __lambda22_ ((Game*) self, (ObjectType) ((gintptr) g));
	return result;
}

static gboolean
game_check_safe (Game* self,
                 GameArenaChange* change)
{
	Arena* temp2_arena = NULL;
	GameArenaChange _tmp0_;
	Arena* _tmp1_;
	GameArenaChange _tmp2_;
	ArenaCoords _tmp3_;
	GameArenaChange _tmp4_;
	ArenaCoords _tmp5_;
	Arena* _tmp6_;
	Arena* _tmp7_;
	GameArenaChange _tmp8_;
	ArenaCoords _tmp9_;
	GameArenaChange _tmp10_;
	ArenaCoords _tmp11_;
	Arena* temp3_arena = NULL;
	Arena* _tmp12_;
	GameArenaChange _tmp13_;
	ArenaCoords _tmp14_;
	GameArenaChange _tmp15_;
	ArenaCoords _tmp16_;
	Arena* _tmp17_;
	Arena* _tmp18_;
	GameArenaChange _tmp19_;
	ArenaCoords _tmp20_;
	GameArenaChange _tmp21_;
	ArenaCoords _tmp22_;
	gboolean result = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (change != NULL, FALSE);
	_tmp0_ = *change;
	_tmp1_ = _tmp0_.arena;
	_tmp2_ = *change;
	_tmp3_ = _tmp2_.player;
	_tmp4_ = *change;
	_tmp5_ = _tmp4_.player;
	_tmp6_ = game_chase (_tmp1_, ___lambda21__gee_predicate, self, _tmp3_.x, _tmp5_.y, NULL, NULL);
	temp2_arena = _tmp6_;
	_tmp7_ = temp2_arena;
	_tmp8_ = *change;
	_tmp9_ = _tmp8_.player;
	_tmp10_ = *change;
	_tmp11_ = _tmp10_.player;
	if (arena_get (_tmp7_, _tmp9_.x, _tmp11_.y) != OBJECT_TYPE_PLAYER) {
		result = FALSE;
		_arena_unref0 (temp2_arena);
		return result;
	}
	_tmp12_ = temp2_arena;
	_tmp13_ = *change;
	_tmp14_ = _tmp13_.player;
	_tmp15_ = *change;
	_tmp16_ = _tmp15_.player;
	_tmp17_ = game_chase (_tmp12_, ___lambda22__gee_predicate, self, _tmp14_.x, _tmp16_.y, NULL, NULL);
	temp3_arena = _tmp17_;
	_tmp18_ = temp3_arena;
	_tmp19_ = *change;
	_tmp20_ = _tmp19_.player;
	_tmp21_ = *change;
	_tmp22_ = _tmp21_.player;
	if (arena_get (_tmp18_, _tmp20_.x, _tmp22_.y) != OBJECT_TYPE_PLAYER) {
		result = FALSE;
		_arena_unref0 (temp3_arena);
		_arena_unref0 (temp2_arena);
		return result;
	}
	result = TRUE;
	_arena_unref0 (temp3_arena);
	_arena_unref0 (temp2_arena);
	return result;
}

static ObjectType
__lambda23_ (Game* self,
             ObjectType obj)
{
	ObjectType result = 0;
	if (obj != OBJECT_TYPE_PLAYER) {
		result = obj;
		return result;
	} else {
		result = OBJECT_TYPE_NONE;
		return result;
	}
}

static ObjectType
___lambda23__arena_mapper (ObjectType obj,
                           gpointer self)
{
	ObjectType result;
	result = __lambda23_ ((Game*) self, obj);
	return result;
}

static gpointer
_arena_coords_dup0 (gpointer self)
{
	return self ? arena_coords_dup (self) : NULL;
}

static gpointer
_game_arena_change_dup0 (gpointer self)
{
	return self ? game_arena_change_dup (self) : NULL;
}

static GameArenaChange*
game_try_push_heap (Game* self,
                    gint dx,
                    gint dy)
{
	GameConfig _tmp0_;
	ArenaCoords coords = {0};
	ArenaCoords _tmp1_;
	ArenaCoords _tmp2_ = {0};
	gboolean _tmp3_ = FALSE;
	Arena* _tmp4_;
	ArenaCoords _tmp5_;
	ArenaCoords push_to = {0};
	ArenaCoords _tmp9_ = {0};
	gboolean _tmp10_ = FALSE;
	Arena* _tmp11_;
	ArenaCoords _tmp12_;
	Arena* new_arena = NULL;
	Arena* _tmp16_;
	Arena* _tmp17_;
	Arena* _tmp18_;
	ArenaCoords _tmp19_;
	ArenaCoords _tmp20_;
	Arena* _tmp21_;
	ArenaCoords _tmp22_;
	ArenaCoords _tmp23_;
	Arena* _tmp24_;
	Arena* _tmp25_;
	ArenaCoords _tmp26_;
	ArenaCoords _tmp27_;
	ArenaCoords* _tmp28_;
	GameArenaChange _tmp29_ = {0};
	GameArenaChange _tmp30_;
	GameArenaChange* _tmp31_;
	GameArenaChange* _tmp32_;
	GameArenaChange* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_config;
	if (!_tmp0_.moveable_heaps) {
		result = NULL;
		return result;
	}
	_tmp1_ = self->priv->_player;
	arena_coords_move (&_tmp1_, dx, dy, &_tmp2_);
	coords = _tmp2_;
	_tmp4_ = self->priv->_arena;
	_tmp5_ = coords;
	if (!arena_are_coords_valid (_tmp4_, &_tmp5_)) {
		_tmp3_ = TRUE;
	} else {
		Arena* _tmp6_;
		ArenaCoords _tmp7_;
		ArenaCoords _tmp8_;
		_tmp6_ = self->priv->_arena;
		_tmp7_ = coords;
		_tmp8_ = coords;
		_tmp3_ = arena_get (_tmp6_, _tmp7_.x, _tmp8_.y) != OBJECT_TYPE_HEAP;
	}
	if (_tmp3_) {
		result = NULL;
		return result;
	}
	arena_coords_move (&coords, dx, dy, &_tmp9_);
	push_to = _tmp9_;
	_tmp11_ = self->priv->_arena;
	_tmp12_ = push_to;
	if (!arena_are_coords_valid (_tmp11_, &_tmp12_)) {
		_tmp10_ = TRUE;
	} else {
		Arena* _tmp13_;
		ArenaCoords _tmp14_;
		ArenaCoords _tmp15_;
		_tmp13_ = self->priv->_arena;
		_tmp14_ = push_to;
		_tmp15_ = push_to;
		_tmp10_ = arena_get (_tmp13_, _tmp14_.x, _tmp15_.y) == OBJECT_TYPE_HEAP;
	}
	if (_tmp10_) {
		result = NULL;
		return result;
	}
	_tmp16_ = self->priv->_arena;
	_tmp17_ = arena_map (_tmp16_, ___lambda23__arena_mapper, self);
	new_arena = _tmp17_;
	_tmp18_ = new_arena;
	_tmp19_ = coords;
	_tmp20_ = coords;
	arena_set (_tmp18_, _tmp19_.x, _tmp20_.y, OBJECT_TYPE_PLAYER);
	_tmp21_ = new_arena;
	_tmp22_ = push_to;
	_tmp23_ = push_to;
	arena_set (_tmp21_, _tmp22_.x, _tmp23_.y, OBJECT_TYPE_HEAP);
	_tmp24_ = new_arena;
	_tmp25_ = _arena_ref0 (_tmp24_);
	_tmp26_ = coords;
	_tmp27_ = push_to;
	_tmp28_ = _arena_coords_dup0 (&_tmp27_);
	memset (&_tmp29_, 0, sizeof (GameArenaChange));
	_arena_unref0 (_tmp29_.arena);
	_tmp29_.arena = _tmp25_;
	_tmp29_.player = _tmp26_;
	_arena_coords_free0 (_tmp29_.push);
	_tmp29_.push = _tmp28_;
	_tmp30_ = _tmp29_;
	_tmp31_ = _game_arena_change_dup0 (&_tmp30_);
	_tmp32_ = _tmp31_;
	game_arena_change_destroy (&_tmp30_);
	result = _tmp32_;
	_arena_unref0 (new_arena);
	return result;
}

/**
     * tries to move the player in a given direction
     **/
static GameArenaChange*
game_try_player_move (Game* self,
                      gint dx,
                      gint dy)
{
	ArenaCoords coords = {0};
	ArenaCoords _tmp0_;
	ArenaCoords _tmp1_ = {0};
	Arena* _tmp2_;
	ArenaCoords _tmp3_;
	Arena* _tmp4_;
	ArenaCoords _tmp5_;
	ArenaCoords _tmp6_;
	GameArenaChange* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_player;
	arena_coords_move (&_tmp0_, dx, dy, &_tmp1_);
	coords = _tmp1_;
	_tmp2_ = self->priv->_arena;
	_tmp3_ = coords;
	if (!arena_are_coords_valid (_tmp2_, &_tmp3_)) {
		result = NULL;
		return result;
	}
	_tmp4_ = self->priv->_arena;
	_tmp5_ = coords;
	_tmp6_ = coords;
	if (arena_get (_tmp4_, _tmp5_.x, _tmp6_.y) == OBJECT_TYPE_HEAP) {
		GameArenaChange* _tmp7_;
		_tmp7_ = game_try_push_heap (self, dx, dy);
		result = _tmp7_;
		return result;
	} else {
		ArenaCoords _tmp8_;
		GameArenaChange _tmp9_ = {0};
		GameArenaChange _tmp10_;
		GameArenaChange* _tmp11_;
		GameArenaChange* _tmp12_;
		_tmp8_ = coords;
		game_move_player_to (self, &_tmp8_, &_tmp9_);
		_tmp10_ = _tmp9_;
		_tmp11_ = _game_arena_change_dup0 (&_tmp10_);
		_tmp12_ = _tmp11_;
		game_arena_change_destroy (&_tmp10_);
		result = _tmp12_;
		return result;
	}
}

/**
     * safe_move_available
     *
     * Description:
     * checks to see if a safe move was available to the player
     *
     * Returns:
     * TRUE if there is a possible safe move, FALSE otherwise
     **/
static gboolean
game_safe_move_available (Game* self)
{
	gboolean result = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	{
		gint dx = 0;
		dx = -1;
		{
			gboolean _tmp0_ = FALSE;
			_tmp0_ = TRUE;
			while (TRUE) {
				if (!_tmp0_) {
					gint _tmp1_;
					dx = dx + 1;
					_tmp1_ = dx;
				}
				_tmp0_ = FALSE;
				if (!(dx <= 1)) {
					break;
				}
				{
					gint dy = 0;
					dy = -1;
					{
						gboolean _tmp2_ = FALSE;
						_tmp2_ = TRUE;
						while (TRUE) {
							GameArenaChange* change = NULL;
							GameArenaChange* _tmp4_;
							GameArenaChange* _tmp5_;
							if (!_tmp2_) {
								gint _tmp3_;
								dy = dy + 1;
								_tmp3_ = dy;
							}
							_tmp2_ = FALSE;
							if (!(dy <= 1)) {
								break;
							}
							_tmp4_ = game_try_player_move (self, dx, dy);
							change = _tmp4_;
							_tmp5_ = change;
							if (_tmp5_ != NULL) {
								GameArenaChange* _tmp6_;
								GameArenaChange _tmp7_;
								_tmp6_ = change;
								_tmp7_ = *_tmp6_;
								if (game_check_safe (self, &_tmp7_)) {
									result = TRUE;
									_game_arena_change_free0 (change);
									return result;
								}
							}
							_game_arena_change_free0 (change);
						}
					}
				}
			}
		}
	}
	result = FALSE;
	return result;
}

static ObjectType
__lambda24_ (Game* self,
             ObjectType obj)
{
	ObjectType result = 0;
	if (obj != OBJECT_TYPE_PLAYER) {
		result = obj;
		return result;
	} else {
		result = OBJECT_TYPE_NONE;
		return result;
	}
}

static ObjectType
___lambda24__arena_mapper (ObjectType obj,
                           gpointer self)
{
	ObjectType result;
	result = __lambda24_ ((Game*) self, obj);
	return result;
}

static void
game_move_player_to (Game* self,
                     ArenaCoords* coords,
                     GameArenaChange* result)
{
	Arena* new_arena = NULL;
	Arena* _tmp0_;
	Arena* _tmp1_;
	Arena* _tmp2_;
	ArenaCoords _tmp3_;
	ArenaCoords _tmp4_;
	Arena* _tmp8_;
	Arena* _tmp9_;
	ArenaCoords _tmp10_;
	GameArenaChange _tmp11_ = {0};
	g_return_if_fail (self != NULL);
	g_return_if_fail (coords != NULL);
	_tmp0_ = self->priv->_arena;
	_tmp1_ = arena_map (_tmp0_, ___lambda24__arena_mapper, self);
	new_arena = _tmp1_;
	_tmp2_ = new_arena;
	_tmp3_ = *coords;
	_tmp4_ = *coords;
	if (arena_get (_tmp2_, _tmp3_.x, _tmp4_.y) == OBJECT_TYPE_NONE) {
		Arena* _tmp5_;
		ArenaCoords _tmp6_;
		ArenaCoords _tmp7_;
		_tmp5_ = new_arena;
		_tmp6_ = *coords;
		_tmp7_ = *coords;
		arena_set (_tmp5_, _tmp6_.x, _tmp7_.y, OBJECT_TYPE_PLAYER);
	}
	_tmp8_ = new_arena;
	_tmp9_ = _arena_ref0 (_tmp8_);
	_tmp10_ = *coords;
	memset (&_tmp11_, 0, sizeof (GameArenaChange));
	_arena_unref0 (_tmp11_.arena);
	_tmp11_.arena = _tmp9_;
	_tmp11_.player = _tmp10_;
	_arena_coords_free0 (_tmp11_.push);
	_tmp11_.push = NULL;
	*result = _tmp11_;
	_arena_unref0 (new_arena);
	return;
}

/**
     * player_move
     * @dx: x direction
     * @dy: y direction
     *
     * Description:
     * moves the player in a given direction
     *
     * Returns:
     * TRUE if the player can move, FALSE otherwise
     **/
static gboolean
game_player_move (Game* self,
                  gint dx,
                  gint dy,
                  GameMoveSafety safety)
{
	GameArenaChange* change = NULL;
	GameArenaChange* _tmp0_;
	GameArenaChange* _tmp1_;
	GameArenaChange* _tmp5_;
	GameArenaChange _tmp6_;
	gboolean result = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = game_try_player_move (self, dx, dy);
	change = _tmp0_;
	_tmp1_ = change;
	if (_tmp1_ == NULL) {
		result = FALSE;
		_game_arena_change_free0 (change);
		return result;
	}
	if (safety != GAME_MOVE_SAFETY_UNSAFE) {
		GameArenaChange* _tmp2_;
		GameArenaChange _tmp3_;
		_tmp2_ = change;
		_tmp3_ = *_tmp2_;
		if (!game_check_safe (self, &_tmp3_)) {
			gboolean _tmp4_ = FALSE;
			if (safety == GAME_MOVE_SAFETY_SUPER_SAFE) {
				_tmp4_ = TRUE;
			} else {
				_tmp4_ = game_safe_move_available (self);
			}
			if (_tmp4_) {
				result = FALSE;
				_game_arena_change_free0 (change);
				return result;
			}
		}
	}
	game_set_splat (self, NULL);
	_tmp5_ = change;
	_tmp6_ = *_tmp5_;
	game_update_arena (self, &_tmp6_);
	result = TRUE;
	_game_arena_change_free0 (change);
	return result;
}

/**
     * random_teleport
     *
     * Description:
     * randomly teleports the player
     *
     * Returns:
     * TRUE if the player can be teleported, FALSE otherwise
     **/
static gboolean
game_random_teleport (Game* self)
{
	gint rand_x = 0;
	GRand* _tmp0_;
	Arena* _tmp1_;
	gint _tmp2_;
	gint _tmp3_;
	gint rand_y = 0;
	GRand* _tmp4_;
	Arena* _tmp5_;
	gint _tmp6_;
	gint _tmp7_;
	gboolean result = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = self->priv->rand;
	_tmp1_ = self->priv->_arena;
	_tmp2_ = arena_get_width (_tmp1_);
	_tmp3_ = _tmp2_;
	rand_x = (gint) g_rand_int_range (_tmp0_, (gint32) 0, (gint32) _tmp3_);
	_tmp4_ = self->priv->rand;
	_tmp5_ = self->priv->_arena;
	_tmp6_ = arena_get_height (_tmp5_);
	_tmp7_ = _tmp6_;
	rand_y = (gint) g_rand_int_range (_tmp4_, (gint32) 0, (gint32) _tmp7_);
	{
		ArenaIterableIterator* _p_it = NULL;
		Arena* _tmp8_;
		ArenaIterable* _tmp9_;
		ArenaIterable* _tmp10_;
		ArenaIterableIterator* _tmp11_;
		ArenaIterableIterator* _tmp12_;
		ArenaCoords* p = NULL;
		_tmp8_ = self->priv->_arena;
		_tmp9_ = arena_iterate_from (_tmp8_, rand_x, rand_y);
		_tmp10_ = _tmp9_;
		_tmp11_ = arena_iterable_iterator (_tmp10_);
		_tmp12_ = _tmp11_;
		_arena_iterable_unref0 (_tmp10_);
		_p_it = _tmp12_;
		while (TRUE) {
			ArenaIterableIterator* _tmp13_;
			ArenaCoords* _tmp14_;
			ArenaCoords* _tmp15_;
			Arena* _tmp16_;
			ArenaCoords* _tmp17_;
			ArenaCoords* _tmp18_;
			GameArenaChange change = {0};
			ArenaCoords* _tmp19_;
			ArenaCoords _tmp20_;
			GameArenaChange _tmp21_ = {0};
			GameArenaChange _tmp22_;
			_tmp13_ = _p_it;
			_tmp14_ = arena_iterable_iterator_next_value (_tmp13_);
			_arena_coords_free0 (p);
			p = _tmp14_;
			_tmp15_ = p;
			if (!(_tmp15_ != NULL)) {
				break;
			}
			_tmp16_ = self->priv->_arena;
			_tmp17_ = p;
			_tmp18_ = p;
			if (arena_get (_tmp16_, (*_tmp17_).x, (*_tmp18_).y) != OBJECT_TYPE_NONE) {
				continue;
			}
			_tmp19_ = p;
			_tmp20_ = *_tmp19_;
			game_move_player_to (self, &_tmp20_, &_tmp21_);
			change = _tmp21_;
			_tmp22_ = change;
			game_update_arena (self, &_tmp22_);
			game_set_splat (self, NULL);
			g_signal_emit (self, game_signals[GAME_GAME_EVENT_SIGNAL], 0, GAME_EVENT_TELEPORTED, 0);
			result = TRUE;
			game_arena_change_destroy (&change);
			_arena_coords_free0 (p);
			_arena_iterable_iterator_unref0 (_p_it);
			return result;
		}
		_arena_coords_free0 (p);
		_arena_iterable_iterator_unref0 (_p_it);
	}
	g_signal_emit (self, game_signals[GAME_GAME_EVENT_SIGNAL], 0, GAME_EVENT_NO_TELEPORT_LOCATIONS, 0);
	result = FALSE;
	return result;
}

/**
     * safe_teleport
     *
     * Description:
     * teleports the player to safe location
     *
     * Returns:
     * TRUE if player can be teleported, FALSE otherwise
     **/
static gboolean
game_safe_teleport (Game* self)
{
	gint rand_x = 0;
	GRand* _tmp0_;
	Arena* _tmp1_;
	gint _tmp2_;
	gint _tmp3_;
	gint rand_y = 0;
	GRand* _tmp4_;
	Arena* _tmp5_;
	gint _tmp6_;
	gint _tmp7_;
	gboolean result = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	if (self->priv->safe_teleports <= 0) {
		result = FALSE;
		return result;
	}
	_tmp0_ = self->priv->rand;
	_tmp1_ = self->priv->_arena;
	_tmp2_ = arena_get_width (_tmp1_);
	_tmp3_ = _tmp2_;
	rand_x = (gint) g_rand_int_range (_tmp0_, (gint32) 0, (gint32) _tmp3_);
	_tmp4_ = self->priv->rand;
	_tmp5_ = self->priv->_arena;
	_tmp6_ = arena_get_height (_tmp5_);
	_tmp7_ = _tmp6_;
	rand_y = (gint) g_rand_int_range (_tmp4_, (gint32) 0, (gint32) _tmp7_);
	{
		ArenaIterableIterator* _p_it = NULL;
		Arena* _tmp8_;
		ArenaIterable* _tmp9_;
		ArenaIterable* _tmp10_;
		ArenaIterableIterator* _tmp11_;
		ArenaIterableIterator* _tmp12_;
		ArenaCoords* p = NULL;
		_tmp8_ = self->priv->_arena;
		_tmp9_ = arena_iterate_from (_tmp8_, rand_x, rand_y);
		_tmp10_ = _tmp9_;
		_tmp11_ = arena_iterable_iterator (_tmp10_);
		_tmp12_ = _tmp11_;
		_arena_iterable_unref0 (_tmp10_);
		_p_it = _tmp12_;
		while (TRUE) {
			ArenaIterableIterator* _tmp13_;
			ArenaCoords* _tmp14_;
			ArenaCoords* _tmp15_;
			Arena* _tmp16_;
			ArenaCoords* _tmp17_;
			ArenaCoords* _tmp18_;
			GameArenaChange change = {0};
			ArenaCoords* _tmp19_;
			ArenaCoords _tmp20_;
			GameArenaChange _tmp21_ = {0};
			GameArenaChange _tmp22_;
			GameArenaChange _tmp23_;
			_tmp13_ = _p_it;
			_tmp14_ = arena_iterable_iterator_next_value (_tmp13_);
			_arena_coords_free0 (p);
			p = _tmp14_;
			_tmp15_ = p;
			if (!(_tmp15_ != NULL)) {
				break;
			}
			_tmp16_ = self->priv->_arena;
			_tmp17_ = p;
			_tmp18_ = p;
			if (arena_get (_tmp16_, (*_tmp17_).x, (*_tmp18_).y) != OBJECT_TYPE_NONE) {
				continue;
			}
			_tmp19_ = p;
			_tmp20_ = *_tmp19_;
			game_move_player_to (self, &_tmp20_, &_tmp21_);
			change = _tmp21_;
			_tmp22_ = change;
			if (!game_check_safe (self, &_tmp22_)) {
				game_arena_change_destroy (&change);
				continue;
			}
			self->priv->safe_teleports = self->priv->safe_teleports - 1;
			_tmp23_ = change;
			game_update_arena (self, &_tmp23_);
			game_set_splat (self, NULL);
			g_signal_emit (self, game_signals[GAME_GAME_EVENT_SIGNAL], 0, GAME_EVENT_TELEPORTED, 0);
			result = TRUE;
			game_arena_change_destroy (&change);
			_arena_coords_free0 (p);
			_arena_iterable_iterator_unref0 (_p_it);
			return result;
		}
		_arena_coords_free0 (p);
		_arena_iterable_iterator_unref0 (_p_it);
	}
	g_signal_emit (self, game_signals[GAME_GAME_EVENT_SIGNAL], 0, GAME_EVENT_NO_SAFE_TELEPORT_LOCATIONS, 0);
	game_kill_player (self);
	result = FALSE;
	return result;
}

/**
     * handles player's commands
     **/
gboolean
game_player_command (Game* self,
                     PlayerCommand cmd,
                     GameMoveSafety safety)
{
	GameState _tmp0_;
	gboolean result = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = self->priv->_state;
	if (_tmp0_ != GAME_STATE_PLAYING) {
		result = FALSE;
		return result;
	}
	switch (cmd) {
		case PLAYER_COMMAND_NW:
		case PLAYER_COMMAND_N:
		case PLAYER_COMMAND_NE:
		case PLAYER_COMMAND_W:
		case PLAYER_COMMAND_STAY:
		case PLAYER_COMMAND_E:
		case PLAYER_COMMAND_SW:
		case PLAYER_COMMAND_S:
		case PLAYER_COMMAND_SE:
		{
			gint dx = 0;
			gint dy = 0;
			gint _tmp1_ = 0;
			gint _tmp2_ = 0;
			gboolean _tmp3_;
			_tmp3_ = player_command_to_direction (cmd, &_tmp1_, &_tmp2_);
			dx = _tmp1_;
			dy = _tmp2_;
			_vala_assert (_tmp3_, "cmd.to_direction (out dx, out dy)");
			if (game_player_move (self, dx, dy, safety)) {
				game_move_robots (self);
				result = TRUE;
				return result;
			} else {
				result = FALSE;
				return result;
			}
		}
		case PLAYER_COMMAND_SAFE_TELEPORT:
		{
			if (game_safe_teleport (self)) {
				game_move_robots (self);
			}
			result = TRUE;
			return result;
		}
		case PLAYER_COMMAND_RANDOM_TELEPORT:
		{
			if (game_random_teleport (self)) {
				game_move_robots (self);
			}
			result = TRUE;
			return result;
		}
		case PLAYER_COMMAND_WAIT:
		{
			game_set_state (self, GAME_STATE_WAITING);
			result = TRUE;
			return result;
		}
		default:
		{
			result = FALSE;
			return result;
		}
	}
}

GameState
game_get_state (Game* self)
{
	GameState result;
	g_return_val_if_fail (self != NULL, 0);
	result = self->priv->_state;
	return result;
}

static void
game_set_state (Game* self,
                GameState value)
{
	g_return_if_fail (self != NULL);
	self->priv->_state = value;
}

Arena*
game_get_arena (Game* self)
{
	Arena* result;
	Arena* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_arena;
	result = _tmp0_;
	return result;
}

static void
game_set_arena (Game* self,
                Arena* value)
{
	Arena* _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = _arena_ref0 (value);
	_arena_unref0 (self->priv->_arena);
	self->priv->_arena = _tmp0_;
}

void
game_get_config (Game* self,
                 GameConfig * result)
{
	GameConfig _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->_config;
	*result = _tmp0_;
	return;
}

void
game_set_config (Game* self,
                 GameConfig * value)
{
	GameConfig _tmp0_;
	GameConfig _tmp1_;
	GameConfig _tmp2_ = {0};
	g_return_if_fail (self != NULL);
	_tmp0_ = *value;
	_tmp1_ = _tmp0_;
	game_config_copy (&_tmp1_, &_tmp2_);
	game_config_destroy (&self->priv->_config);
	self->priv->_config = _tmp2_;
}

gint
game_get_width (Game* self)
{
	gint result;
	Arena* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	g_return_val_if_fail (self != NULL, 0);
	_tmp0_ = self->priv->_arena;
	_tmp1_ = arena_get_width (_tmp0_);
	_tmp2_ = _tmp1_;
	result = _tmp2_;
	return result;
}

gint
game_get_height (Game* self)
{
	gint result;
	Arena* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	g_return_val_if_fail (self != NULL, 0);
	_tmp0_ = self->priv->_arena;
	_tmp1_ = arena_get_height (_tmp0_);
	_tmp2_ = _tmp1_;
	result = _tmp2_;
	return result;
}

void
game_get_player (Game* self,
                 ArenaCoords * result)
{
	ArenaCoords _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->_player;
	*result = _tmp0_;
	return;
}

static void
game_set_player (Game* self,
                 ArenaCoords * value)
{
	ArenaCoords _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = *value;
	self->priv->_player = _tmp0_;
}

ArenaCoords*
game_get_splat (Game* self)
{
	ArenaCoords* result;
	ArenaCoords* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_splat;
	result = _tmp0_;
	return result;
}

static void
game_set_splat (Game* self,
                ArenaCoords* value)
{
	ArenaCoords* _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = _arena_coords_dup0 (value);
	_arena_coords_free0 (self->priv->_splat);
	self->priv->_splat = _tmp0_;
}

void
game_get_status (Game* self,
                 GameStatus * result)
{
	GameStatus _tmp0_ = {0};
	g_return_if_fail (self != NULL);
	memset (&_tmp0_, 0, sizeof (GameStatus));
	_tmp0_.score = self->priv->score;
	_tmp0_.current_level = self->priv->current_level + 1;
	_tmp0_.safe_teleports = self->priv->safe_teleports;
	*result = _tmp0_;
	return;
}

static void
g_cclosure_user_marshal_VOID__ENUM_INT (GClosure * closure,
                                        GValue * return_value,
                                        guint n_param_values,
                                        const GValue * param_values,
                                        gpointer invocation_hint,
                                        gpointer marshal_data)
{
	typedef void (*GMarshalFunc_VOID__ENUM_INT) (gpointer data1, gint arg_1, gint arg_2, gpointer data2);
	register GMarshalFunc_VOID__ENUM_INT callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
	g_return_if_fail (n_param_values == 3);
	if (G_CCLOSURE_SWAP_DATA (closure)) {
		data1 = closure->data;
		data2 = param_values->data[0].v_pointer;
	} else {
		data1 = param_values->data[0].v_pointer;
		data2 = closure->data;
	}
	callback = (GMarshalFunc_VOID__ENUM_INT) (marshal_data ? marshal_data : cc->callback);
	callback (data1, g_value_get_enum (param_values + 1), g_value_get_int (param_values + 2), data2);
}

GameStatus*
game_status_dup (const GameStatus* self)
{
	GameStatus* dup;
	dup = g_new0 (GameStatus, 1);
	memcpy (dup, self, sizeof (GameStatus));
	return dup;
}

void
game_status_free (GameStatus* self)
{
	g_free (self);
}

static GType
game_status_get_type_once (void)
{
	GType game_status_type_id;
	game_status_type_id = g_boxed_type_register_static ("GameStatus", (GBoxedCopyFunc) game_status_dup, (GBoxedFreeFunc) game_status_free);
	return game_status_type_id;
}

GType
game_status_get_type (void)
{
	static volatile gsize game_status_type_id__volatile = 0;
	if (g_once_init_enter (&game_status_type_id__volatile)) {
		GType game_status_type_id;
		game_status_type_id = game_status_get_type_once ();
		g_once_init_leave (&game_status_type_id__volatile, game_status_type_id);
	}
	return game_status_type_id__volatile;
}

static void
game_arena_change_copy (const GameArenaChange* self,
                        GameArenaChange* dest)
{
	Arena* _tmp0_;
	Arena* _tmp1_;
	ArenaCoords _tmp2_;
	ArenaCoords* _tmp3_;
	ArenaCoords* _tmp4_;
	_tmp0_ = (*self).arena;
	_tmp1_ = _arena_ref0 (_tmp0_);
	_arena_unref0 ((*dest).arena);
	(*dest).arena = _tmp1_;
	_tmp2_ = (*self).player;
	(*dest).player = _tmp2_;
	_tmp3_ = (*self).push;
	_tmp4_ = _arena_coords_dup0 (_tmp3_);
	_arena_coords_free0 ((*dest).push);
	(*dest).push = _tmp4_;
}

static void
game_arena_change_destroy (GameArenaChange* self)
{
	_arena_unref0 ((*self).arena);
	_arena_coords_free0 ((*self).push);
}

static GameArenaChange*
game_arena_change_dup (const GameArenaChange* self)
{
	GameArenaChange* dup;
	dup = g_new0 (GameArenaChange, 1);
	game_arena_change_copy (self, dup);
	return dup;
}

static void
game_arena_change_free (GameArenaChange* self)
{
	game_arena_change_destroy (self);
	g_free (self);
}

static GType
game_arena_change_get_type_once (void)
{
	GType game_arena_change_type_id;
	game_arena_change_type_id = g_boxed_type_register_static ("GameArenaChange", (GBoxedCopyFunc) game_arena_change_dup, (GBoxedFreeFunc) game_arena_change_free);
	return game_arena_change_type_id;
}

static GType
game_arena_change_get_type (void)
{
	static volatile gsize game_arena_change_type_id__volatile = 0;
	if (g_once_init_enter (&game_arena_change_type_id__volatile)) {
		GType game_arena_change_type_id;
		game_arena_change_type_id = game_arena_change_get_type_once ();
		g_once_init_leave (&game_arena_change_type_id__volatile, game_arena_change_type_id);
	}
	return game_arena_change_type_id__volatile;
}

static void
value_game_init (GValue* value)
{
	value->data[0].v_pointer = NULL;
}

static void
value_game_free_value (GValue* value)
{
	if (value->data[0].v_pointer) {
		game_unref (value->data[0].v_pointer);
	}
}

static void
value_game_copy_value (const GValue* src_value,
                       GValue* dest_value)
{
	if (src_value->data[0].v_pointer) {
		dest_value->data[0].v_pointer = game_ref (src_value->data[0].v_pointer);
	} else {
		dest_value->data[0].v_pointer = NULL;
	}
}

static gpointer
value_game_peek_pointer (const GValue* value)
{
	return value->data[0].v_pointer;
}

static gchar*
value_game_collect_value (GValue* value,
                          guint n_collect_values,
                          GTypeCValue* collect_values,
                          guint collect_flags)
{
	if (collect_values[0].v_pointer) {
		Game * object;
		object = collect_values[0].v_pointer;
		if (object->parent_instance.g_class == NULL) {
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		}
		value->data[0].v_pointer = game_ref (object);
	} else {
		value->data[0].v_pointer = NULL;
	}
	return NULL;
}

static gchar*
value_game_lcopy_value (const GValue* value,
                        guint n_collect_values,
                        GTypeCValue* collect_values,
                        guint collect_flags)
{
	Game ** object_p;
	object_p = collect_values[0].v_pointer;
	if (!object_p) {
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
	}
	if (!value->data[0].v_pointer) {
		*object_p = NULL;
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
		*object_p = value->data[0].v_pointer;
	} else {
		*object_p = game_ref (value->data[0].v_pointer);
	}
	return NULL;
}

GParamSpec*
param_spec_game (const gchar* name,
                 const gchar* nick,
                 const gchar* blurb,
                 GType object_type,
                 GParamFlags flags)
{
	ParamSpecGame* spec;
	g_return_val_if_fail (g_type_is_a (object_type, TYPE_GAME), NULL);
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
	G_PARAM_SPEC (spec)->value_type = object_type;
	return G_PARAM_SPEC (spec);
}

gpointer
value_get_game (const GValue* value)
{
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_GAME), NULL);
	return value->data[0].v_pointer;
}

void
value_set_game (GValue* value,
                gpointer v_object)
{
	Game * old;
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_GAME));
	old = value->data[0].v_pointer;
	if (v_object) {
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_GAME));
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
		value->data[0].v_pointer = v_object;
		game_ref (value->data[0].v_pointer);
	} else {
		value->data[0].v_pointer = NULL;
	}
	if (old) {
		game_unref (old);
	}
}

void
value_take_game (GValue* value,
                 gpointer v_object)
{
	Game * old;
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_GAME));
	old = value->data[0].v_pointer;
	if (v_object) {
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_GAME));
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
		value->data[0].v_pointer = v_object;
	} else {
		value->data[0].v_pointer = NULL;
	}
	if (old) {
		game_unref (old);
	}
}

static void
game_class_init (GameClass * klass,
                 gpointer klass_data)
{
	game_parent_class = g_type_class_peek_parent (klass);
	((GameClass *) klass)->finalize = game_finalize;
	g_type_class_adjust_private_offset (klass, &Game_private_offset);
	game_signals[GAME_GAME_EVENT_SIGNAL] = g_signal_new ("game-event", TYPE_GAME, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__ENUM_INT, G_TYPE_NONE, 2, GAME_TYPE_EVENT, G_TYPE_INT);
}

static void
game_instance_init (Game * self,
                    gpointer klass)
{
	self->priv = game_get_instance_private (self);
	self->priv->endlev_counter = 0;
	self->priv->current_level = 0;
	self->priv->score = 0;
	self->priv->kills = 0;
	self->priv->score_step = 0;
	self->priv->safe_teleports = 0;
	self->ref_count = 1;
}

static void
game_finalize (Game * obj)
{
	Game * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_GAME, Game);
	g_signal_handlers_destroy (self);
	_arena_unref0 (self->priv->_arena);
	game_config_destroy (&self->priv->_config);
	_arena_coords_free0 (self->priv->_splat);
	_g_rand_free0 (self->priv->rand);
}

static GType
game_get_type_once (void)
{
	static const GTypeValueTable g_define_type_value_table = { value_game_init, value_game_free_value, value_game_copy_value, value_game_peek_pointer, "p", value_game_collect_value, "p", value_game_lcopy_value };
	static const GTypeInfo g_define_type_info = { sizeof (GameClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) game_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (Game), 0, (GInstanceInitFunc) game_instance_init, &g_define_type_value_table };
	static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
	GType game_type_id;
	game_type_id = g_type_register_fundamental (g_type_fundamental_next (), "Game", &g_define_type_info, &g_define_type_fundamental_info, 0);
	Game_private_offset = g_type_add_instance_private (game_type_id, sizeof (GamePrivate));
	return game_type_id;
}

GType
game_get_type (void)
{
	static volatile gsize game_type_id__volatile = 0;
	if (g_once_init_enter (&game_type_id__volatile)) {
		GType game_type_id;
		game_type_id = game_get_type_once ();
		g_once_init_leave (&game_type_id__volatile, game_type_id);
	}
	return game_type_id__volatile;
}

gpointer
game_ref (gpointer instance)
{
	Game * self;
	self = instance;
	g_atomic_int_inc (&self->ref_count);
	return instance;
}

void
game_unref (gpointer instance)
{
	Game * self;
	self = instance;
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
		GAME_GET_CLASS (self)->finalize (self);
		g_type_free_instance ((GTypeInstance *) self);
	}
}

